////////////////////////////////////////////////////////////////////
//
//  Tutorial uso di MySql con driver ODBC della actual technologies
//
//  Created by Francesco Germinara 
// 
//  Freeware (c) 2005 SofTech di F.Germinara - www.germinara.it. 
//
//  For information please contact me at info@germinara.it 
////////////////////////////////////////////////////////////////////
//  History:
//
//  Description:
//
////////////////////////////////////////////////////////////////////

#import "panelPersoneController.h"

#import "NSString+FGString.h" //Expand NSString class using Categories
#import "FGBseData.h"         //manage Data field

@implementation panelPersoneController


- (void) dealloc {
	[dsPersone release];
	[super dealloc];
}


-(void) awakeFromNib{
  dsPersone=[[FGODBCResultSet alloc] init:theApp SetIdentifier:@"PERSONE" tableView:elencoPersone];
  
  [self setCtrlStat:TRUE]; //enable/disable control in user interface
  
  [elencoPersone setTarget:self];
  [elencoPersone setDoubleAction:@selector(loadSelectedData)]; //Double click
 
  
}

- (void)windowDidBecomeKey:(NSNotification *)aNotification{
 static int bOnlyOnce=0;
 if(!bOnlyOnce){
  [self startUseDataSource];
  bOnlyOnce=1;
 }
}

-(void) startUseDataSource{
 [elencoPersone setDataSource:nil];
   //Execute the query for dataset result 
 [dsPersone FillArray:theApp->pTabPersone SqlFilter:@"order by ID_PERSONA" ProgressInd:nil]; 
 //Set datasource to tableview
 [elencoPersone setDataSource:dsPersone];
 }

- (IBAction)btnBarraAzionePremuto:(id)sender
{
 //Chiudo la finestra
 int nOperationToDo=0;
 nOperationToDo=[sender selectedSegment]; //Get the Button That is selected on the segment
 id aPanel=[sender window];
 
  if(nOperationToDo == 0){ //REGISTRA was pressed Insert/Modify the record
   [self updateRecord];
  
   [self startUseDataSource];    //refresh datasource 
   
   [self setCtrlStat:TRUE];
   [self clearFelds];
  }
  
 if(nOperationToDo == 1){ //CANCELLA was pressed Delete the record
	NSString *strInfo;
	strInfo=[NSString stringWithFormat:@"Do you want delete %@.  Are you sure ?",[[idPersona stringValue]TrimRight]];
	int rc=NSRunAlertPanel(@"Warning!",strInfo,@"YES",@"NO",nil);
	if(rc==NSOKButton){	
     [self deleteRecord];
  
    [self startUseDataSource];    //refresh datasource 
	
	[self setCtrlStat:TRUE];
	[self clearFelds];
   }
  }

 if(nOperationToDo == 2){ //ELIMINA TUTTI was pressed Delete all records
  NSString *strInfo;
  strInfo=[NSString stringWithString:@"Do you want remove all records. Are you sure ?"];
  int rc=NSRunAlertPanel(@"Warning!",strInfo,@"YES",@"NO",nil);
  if(rc==NSOKButton){	
   [self deleteAllRecords];
  
   [self startUseDataSource];    //refresh datasource 
   
   [self setCtrlStat:TRUE];
   [self clearFelds];
   }
  }
  
  if(nOperationToDo == 3){ //STAMPA was pressed Print all records
   [elencoPersone print:self];
  }
 

 if(nOperationToDo == 4){      //ESCI was pressed close sheet  
  [self setCtrlStat:TRUE];
  [aPanel  orderOut:nil];      //Close the panel
  [NSApp endSheet:aPanel ];    //End the sheet loop
 }
 
}

- (IBAction)btnModificaPremuto:(id)sender
{

//1: Check if key field is valid
NSString *aString=[[idPersona stringValue] TrimRight]; //Eliminate right blanks

if([aString isEqualToString:@""]){
 NSRunAlertPanel(@"ERROR",@"You must specify a valid id for a person!",@"OK",nil,nil);
 return;
}

if([aString length] >25){
 NSRunAlertPanel(@"ERROR",@"Lenght must not exceed 25 character!",@"OK",nil,nil);
 return;
}

//2: Check if record already present
NSMutableString *strQuery;
strQuery=[NSMutableString stringWithFormat:@"WHERE ID_PERSONA='%@' ",aString]; //Build the query 

if([theApp->pTabPersone LoadDati:strQuery] == TRUE){
 NSLog(@"Found: %@ in table PERSONE",aString);
 //Update info in user interface
 [descrizione setStringValue:[[theApp->pTabPersone FieldInfo:@"DESCR"] GetValue]];
 [eta setStringValue:[[theApp->pTabPersone FieldInfo:@"ETA"] GetValue]];
 [hobby setStringValue:[[theApp->pTabPersone FieldInfo:@"HOBBY"] GetValue]];
 [sport setStringValue:[[theApp->pTabPersone FieldInfo:@"SPORT"] GetValue]];
 [budget setStringValue:[[theApp->pTabPersone FieldInfo:@"BUDGET"] GetValue]];
 [flgSingle setState:[[[theApp->pTabPersone FieldInfo:@"SINGLE"] GetValue] intValue]];
 FGBseData *aDate=[[FGBseData alloc] init];
 [aDate SetDataR:[[theApp->pTabPersone FieldInfo:@"NATOIL"] GetValue]];
 [dataNascita setDateValue:[aDate GetCalendarDate]];
 [aDate release];
}else{
 NSLog(@"Not Found: %@ in table PERSONE",aString);
 //New record, clear fields
 [descrizione setStringValue:@""];
 [eta setStringValue:@""];
 [hobby setStringValue:@""];
 [sport setStringValue:@""];
 [budget setStringValue:@""];
 [flgSingle setState:FALSE]; 
}

[self setCtrlStat:FALSE];

}

//Update Record
-(void)updateRecord{
NSMutableString *strQuery;
NSString *aString=[[idPersona stringValue] TrimRight]; //Eliminate right blanks

strQuery=[NSMutableString stringWithFormat:@"WHERE ID_PERSONA='%@' ",aString]; //Build the query 
BOOL sts=[theApp->pTabPersone LoadDati:strQuery]; //New Insert or Update ?

//Assign new data value for the record	
[[theApp->pTabPersone FieldInfo:@"ID_PERSONA"] SetValue:aString];	
[[theApp->pTabPersone FieldInfo:@"DESCR"] SetValue:[descrizione stringValue]];	
[[theApp->pTabPersone FieldInfo:@"ETA"] SetValue:[eta stringValue]]; //Int
[[theApp->pTabPersone FieldInfo:@"HOBBY"] SetValue:[hobby stringValue]];
[[theApp->pTabPersone FieldInfo:@"SPORT"] SetValue:[sport stringValue]];
if([flgSingle state]==TRUE)
 [[theApp->pTabPersone FieldInfo:@"SINGLE"] SetValue:@"1"];
else
 [[theApp->pTabPersone FieldInfo:@"SINGLE"] SetValue:@"0"];
[[theApp->pTabPersone FieldInfo:@"NATOIL"] SetValue:[[dataNascita dateValue] descriptionWithCalendarFormat:@"%Y%m%d" timeZone:nil locale:nil]]; //data YYYYMMDD
[[theApp->pTabPersone FieldInfo:@"BUDGET"] SetValue:[budget stringValue]]; //real
 	
 //If not exist make a INSERT else a UPDATE	
 if(sts==FALSE)
  [theApp->pTabPersone Insert];
 else
  [theApp->pTabPersone Update:strQuery];

}

//Delete Record
-(void)deleteRecord{
NSMutableString *strQuery;
NSString *aString=[[idPersona stringValue] TrimRight]; //Eliminate right blanks

strQuery=[NSMutableString stringWithFormat:@"WHERE ID_PERSONA='%@' ",aString]; //Build the query 
[theApp->pTabPersone Delete:strQuery]; 
}

//Delete all records
-(void)deleteAllRecords{
 [theApp->pTabPersone Delete:@""]; 
}

//enable/disable control in user interface
-(void)setCtrlStat:(BOOL) bSts{

 [idPersona setEnabled:bSts];
 [budget setEnabled:!bSts];
 [descrizione setEnabled:!bSts];
 [dataNascita setEnabled:!bSts];
 [eta setEnabled:!bSts];
 [flgSingle setEnabled:!bSts];
 [sport setEnabled:!bSts];
 [hobby setEnabled:!bSts];
 [flgSingle setEnabled:!bSts];
 
 [pulsantiAzione setEnabled:!bSts forSegment:0]; //Enable/Disable REGISTRA
 [pulsantiAzione setEnabled:!bSts forSegment:1]; //Enable/Disable CANCELLA
 [btnModifica setEnabled:bSts];
}

//Double click action
-(void)loadSelectedData{
 int nSelectedRow=[elencoPersone clickedRow];
 FGODBCRecord *tmpRecord=[dsPersone GetSingleRow:nSelectedRow];

 //Update info in user interface
 [idPersona setStringValue:[[tmpRecord FieldInfo:@"ID_PERSONA"] GetValue]];
 [descrizione setStringValue:[[tmpRecord FieldInfo:@"DESCR"] GetValue]];
 [eta setStringValue:[[tmpRecord FieldInfo:@"ETA"] GetValue]];
 [hobby setStringValue:[[tmpRecord FieldInfo:@"HOBBY"] GetValue]];
 [sport setStringValue:[[tmpRecord FieldInfo:@"SPORT"] GetValue]];
 [budget setStringValue:[[tmpRecord FieldInfo:@"BUDGET"] GetValue]];
 [flgSingle setState:[[[tmpRecord FieldInfo:@"SINGLE"] GetValue] intValue]];
 FGBseData *aDate=[[FGBseData alloc] init];
 [aDate SetDataR:[[tmpRecord FieldInfo:@"NATOIL"] GetValue]];
 [dataNascita setDateValue:[aDate GetCalendarDate]];
 [aDate release];
 [self setCtrlStat:FALSE];
}

//Clear user input fields data
-(void)clearFelds{
 [descrizione setStringValue:@""];
 [eta setStringValue:@""];
 [hobby setStringValue:@""];
 [sport setStringValue:@""];
 [budget setStringValue:@""];
 [flgSingle setState:FALSE]; 
}


@end
