////////////////////////////////////////////////////////////////////
//
//  FGBseData.h
//  
//
//  Created by Francesco Germinara on Fri Jun 18 2004.
// 
//  Copyright (c) 2004 SofTech di F.Germinara - www.germinara.it. All rights reserved.
//
//  For information please contact me at info@germinara.it 
////////////////////////////////////////////////////////////////////
//  History:
//
//  Description:
//
////////////////////////////////////////////////////////////////////


#import <Foundation/Foundation.h>


@interface FGBseData : NSObject {
    NSCalendarDate *interlalCalendarDate; //Data e ora
	
	NSString *datar;           //Data sempre in formato AAAAMMGG
	NSString *data;            //Data Restituita in base al tipo di formato richiesto
	NSString *dataD;		   //Data Restituita sempre nel formato "nomegiorno GG/MM/AAAA"
	NSString *dataG;		   //Data Restituita sempre nel formato "GG/MM"
	
	NSString *orar;            //Ora sempre in formato HH:MM:SS
	
	NSString *strGG;           //Giorno
	NSString  *strMM;          //Mese
	NSString *strAAAA;         //Anno
	
	NSString *strOra;          //Ora
	NSString *strMin;          //Minuti
	NSString *strSec;          //Secondi
	
	int nGG;
	int nMM;
	int nAAAA;
	
	int nOra;
	int nMin;
	int nSec;
}

//Creazione ed assegnazione dei valori
-(id)init; //Costruttore di default
-(void) MkStrDataWithString:(NSString *)gg mese:(NSString *)mm anno:(NSString *) aa; //Crea la data con le informazioni indicate
-(void) MkStrData:(int)gg mese:(int)mm anno:(int) aa; //Crea la data con le informazioni indicate
-(void) ScomponiData; //Scompone la data nelle singole componenti

-(void) MkStrOraWithString:(NSString *) hh minuti:(NSString *) mm secondi:(NSString *) ss; //Crea l'ora indicata
-(void) MkStrOra:(int) hh minuti:(int) mm secondi:(int) ss; //Crea l'ora indicata
-(void) ScomponiOra; //Scompone l'ora nelle singole componenti

-(void) Oggi; //Imposta la data e l'ora corrente
-(void) SetDataAAAAMMGG; //Imposta la data nel formato AAAAMMGG
-(void) SetDataGGMMAAAA; //Imposta la data nel formato GG/MM/AAAA

-(void) SetDataR:(NSString *) dataAAAAMMGG;   //Imposta la data usando una stringa contenente la data nel formato AAAAMMGG
-(void) SetDataVis:(NSString *) dataGGMMAAAA; //Imposta la data usando una stringa contenente la data nel formato GG/MM/AAAA
-(void) SetDataVisUsa:(NSString *) dataMMGGAAAA; //Imposta la data usando una stringa contenente la data nel formato MM/GG/AAAA

-(void) RefreshInternalData:(NSCalendarDate *)newCalendarDate; //Refresh dei dati interni utilizzando il valore di "calendarDate"


//Restituzione dei valori

-(NSString *) Data;  //Restituisce la data in base al formato precedentemente selezionato
-(NSString *) DataR; //Restituisce la data sempre nel formato AAAAMMGG
-(NSString *) DataD; //Restituisce la data sempre nel formato nomegiorno GG/MM/AAAA
-(NSString *) OraR;  //Restituisce ora sempre nel formato HH:MM:SS
-(NSString *) DataG; //Restituisce la data sempre nel formato  GG/MM

-(NSString *) GG;    //Restituisce il giorno
-(NSString *) MM;    //Restituisce il mese
-(NSString *) AA;    //Restituisce l'anno
-(NSString *) Ora;    //Restituisce ora
-(NSString *) Min;    //Restituisce minuti
-(NSString *) Sec;    //Restituisce secondi

-(int) nGG;     //Restituisce il giorno come numero
-(int) nMM;     //Restituisce il mese come numero
-(int) nAA;     //Restituisce l'anno come numero
-(int) nOra;    //Restituisce ora come numero
-(int) nMin;    //Restituisce minuti come numero
-(int) nSec;    //Restituisce secondi come numero

-(NSCalendarDate *) GetCalendarDate; //Restituice l'oggetto NSCalendarDate

//Utility

-(void)DayPrec; //Imposta la data al giorno Precedente
-(void)DaySucc; //Imposta la data al giorno Successivo
-(void)DayOffSet:(int)nDays; //Imposta la Data con l'offset di giorni indicati sia in + sia in -
-(void)DayOffSetFromCurrentDate:(int)nDays; //Imposta la Data con l'offset di giorni indicati sia in + sia in - dalla data odierna


@end
